/*                                                                */
/*  HISTORY:                                                      */
/*  WHO  WHEN    WHAT                                             */
/*  Jim Lovell, Jamie McCallum
/*  Modified version of mout2 to send monitoring data over a socket to fourier.phys.utas.edu.au  */
/*  Port number is 6300 by default */

#include <stdio.h>
#include <signal.h>
#include <math.h>
#include <string.h>
#include <sys/types.h>
/*#include "mparm.h"*/
/*#include "dpi.h"*/
#include "/usr2/fs/include/params.h"
#include "/usr2/fs/include/fs_types.h"
#include "/usr2/fs/include/fscom.h"
#include "/usr2/fs/include/sexagesimal.h"
#include "/usr2/fs/include/pmodel.h"
#include "/usr2/fs/include/dpi.h"

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h> 

                                             /* parameter keywords */
static char *key_mode[ ]={ "prn", "v"  , "m"  , "a"  , "b"  , "c"  ,
			   "b1" , "b2" , "c1" , "c2" ,
                           "d1" , "d2" , "d3" , "d4" , "d5" , "d6" , "d7" ,
                           "d8" , "d9" , "d10", "d11", "d12", "d13", "d14",
                           "d15", "d16", "d17", "d18", "d19", "d20", "d21",
                           "d22", "d23", "d24", "d25", "d26", "d27", "d28"};
#define NKEY_MODE sizeof(key_mode)/sizeof( char *)

static char *key_mode4[]={ "m"  , "a"  , "b1" , "b2" , "c1" , "c2" ,
                           "e1" , "e2" , "e3" , "e4" ,
                           "d1" , "d2" , "d3" , "d4" , "d5" , "d6" , "d7" ,
                           "d8" , "d9" , "d10", "d11", "d12", "d13", "d14",
                           "d15", "d16", "d17", "d18", "d19", "d20", "d21",
                           "d22", "d23", "d24", "d25", "d26", "d27", "d28"};

#define NKEY_MODE4 sizeof(key_mode4)/sizeof( char *)

extern struct fscom *shm_addr;
extern int kMrack, kMdrive[2], kS2drive[2],kVrack,kVdrive[2],kM3rack,kM4rack,
  kV4rack, kLrack, kK4drive[2],kK41drive_type[2],kK42drive_type[2], kDrack,
  selectm;


mdumpout(it,iyear)

int iyear;

{
  int idum;
  int i, sv, k, icr;
  int irah,iram,idecd,idecm;
  int ivalue;
  unsigned int iversion;
  double azim={0.0},elev={0.0};
  double ha={0.0},dc,az,el;
  float outhaa={0.0};
  double xxx={0.0},yyy={0.0};
  float outxxx={0.0},outyyy={0.0};
  float ras;
  double dtemp, htemp,aztemp,eltemp;
  char feet[6];
  char dig[3];
  char outfloat[80];
  char *outf; 
  char checkarr[91];
  char *checkln; 
  char *ptfeet;
  int posdeg;
  double raxx,dcxx;
  void preflt();
  void preint();
  int len;
  int inuse, rstate, rstate_valid, position_valid;
  long int position,posvar;
  SEXAGESIMAL rah,decd,hah;
// Socketry 
  int sockfd, portno;
  struct sockaddr_in serv_addr;
  struct hostent *server;
  portno=63000;
  struct monit5_ping *ping;
  char vsn[9];
  int hours,mins;
  char *index;
  int index2; 
  
  char outbuff[1024];
  char tempbuff[128];
  bzero(outbuff,1024);
  bzero(tempbuff,128);
  strcat(outbuff, "info hb ");


  ptfeet = &feet[0];
  checkln = &checkarr[0];
  outf = &outfloat[0];



  ping=shm_addr->monit5.ping+(shm_addr->monit5.pong)%2;

  if (ping->active==0) {
    strcat(outbuff, "A ");
    } else if (ping->active==1) {
    strcat(outbuff, "B ");
  } else {
    strcat(outbuff,"\t ");
  }
  strcat(outbuff,shm_addr->mk5vsn); strcat(outbuff, " "); 

  strncpy(vsn,ping->bank[0].vsn,8);
  vsn[8]=0;
  if (vsn[0] != '\0') {
  strcat(outbuff,vsn); strcat(outbuff, " "); 
  } else {
  strcat(outbuff,"\t "); 
  }
  strncpy(vsn,ping->bank[1].vsn,8);
  vsn[8]=0;
  if (vsn[0] != '\0') {
  strcat(outbuff,vsn); strcat(outbuff, " "); 
  } else {
  strcat(outbuff,"\t "); 
  }

  if(ping->bank[0].seconds>=0.0) {
    hours=(ping->bank[0].seconds+0.5)/3600.0;
    mins=((ping->bank[0].seconds+0.5)-hours*3600.0)/60.0;
    sprintf(tempbuff, "%dh%.2dm ",hours,mins);
    strcat(outbuff,tempbuff);
    bzero(tempbuff, 128);
  } else {
    strcat(outbuff,"\t ");
  }


  if(ping->bank[1].seconds>=0.0) {
    hours=(ping->bank[1].seconds+0.5)/3600.0;
    mins=((ping->bank[1].seconds+0.5)-hours*3600.0)/60.0;
    sprintf(tempbuff, "%dh%.2dm ",hours,mins);
    strcat(outbuff,tempbuff);
    bzero(tempbuff, 128);
  } else {
    strcat(outbuff, "\t ");
  }

  if(ping->bank[0].gb>=0.0) {
    sprintf(tempbuff, "%4.3lf ",ping->bank[0].gb);
    strcat(outbuff,tempbuff);
    bzero(tempbuff, 128);
  } else
    strcat(outbuff, "\t ");

  if(ping->bank[1].gb>=0.0) {
    sprintf(tempbuff, "%4.3lf ",ping->bank[1].gb);
    strcat(outbuff,tempbuff);
    bzero(tempbuff, 128);
  } else
    strcat(outbuff, "\t ");

  if(ping->bank[0].percent>=0.0) {
    sprintf(tempbuff, "%3.1lf ",ping->bank[0].percent);
    strcat(outbuff,tempbuff);
    bzero(tempbuff, 128);
  } else
    strcat(outbuff,"\t ");
  if(ping->bank[1].percent>=0.0) {
    sprintf(tempbuff, "%3.1lf ",ping->bank[1].percent);
    strcat(outbuff,tempbuff);
    bzero(tempbuff, 128);
  } else
    strcat(outbuff, "\t ");

  if(ping->bank[0].itime[0]>=0) {
    sprintf(tempbuff,"%d:%.2d:%.2d ",
	   ping->bank[0].itime[3],
	   ping->bank[0].itime[2],
	   ping->bank[0].itime[1]);
    strcat(outbuff,tempbuff);
    bzero(tempbuff, 128);
  } else
    strcat(outbuff,"\t ");

  if(ping->bank[1].itime[1]>=0) {
    sprintf(tempbuff,"%d:%.2d:%.2d ",
	   ping->bank[1].itime[3],
	   ping->bank[1].itime[2],
	   ping->bank[1].itime[1]
	   );
    strcat(outbuff,tempbuff);
    bzero(tempbuff, 128);
  } else
    strcat(outbuff,"\t ");

strcat(outbuff, shm_addr->scan_name.name);strcat(outbuff, " ");
  if (shm_addr->KHALT!=0) {            /* schedule halted */
    strcat(outbuff, "yes ");
  } else {
    strcat(outbuff, "no ");
  }

  preint(outf,shm_addr->INEXT[0],-2,1);
  strcat(outbuff,outfloat);strcat(outbuff,":");
  /* move(ROW1+1,COL1+28); */
  preint(outf,shm_addr->INEXT[1],-2,1);
  strcat(outbuff,outfloat);strcat(outbuff,":");
  /* move(ROW1+1,COL1+31); */
  preint(outf,shm_addr->INEXT[2],-2,1);
  strcat(outbuff, outfloat); strcat(outbuff, " ");
  sprintf(tempbuff, "%.8s ", shm_addr->LSKD);
  index2=0; while ( (tempbuff[index2] != ' ') && index2< strlen(tempbuff)) {
    index2++;
  }
  tempbuff[index2]='\0';
  //  index = strchr(tempbuff, ' ');
// index2=(int)(index-tempbuff);
//  tempbuff[index2]="\0" ;
  strcat(outbuff, tempbuff); strcat(outbuff, " ");bzero(tempbuff, 128);
  sprintf(tempbuff, "%.8s ", shm_addr->LLOG);
  index2=0; while ( (tempbuff[index2] != ' ') && index2< strlen(tempbuff)) {
    index2++;
  }
  tempbuff[index2]='\0';
  strcat(outbuff, tempbuff); strcat(outbuff, " ");bzero(tempbuff, 128);
  preflt(outf,shm_addr->tempwx,5,1);
  index2=0; while ( (outfloat[index2] != ' ') && index2< strlen(outfloat)) {
    index2++;
  }
  outfloat[index2]='\0';
  strcat(outbuff, outfloat); strcat(outbuff, " ");
  preflt(outf,shm_addr->humiwx,6,2);
  index2=0; while ( (outfloat[index2] != ' ') && index2< strlen(outfloat)) {
    index2++;
  }
  outfloat[index2]='\0';
  strcat(outbuff, outfloat); strcat(outbuff, " ");
  preflt(outf,shm_addr->preswx,6,1);
  index2=0; while ( (outfloat[index2] != ' ') && index2< strlen(outfloat)) {
    index2++;
  }
  outfloat[index2]='\0';
  strcat(outbuff, outfloat); strcat(outbuff, " ");

  //az=st->monan.pos_should.az-st->monan.error.azcor;
  //az=fmod(az+DTWOPI,DTWOPI);
  sprintf(tempbuff , " ");
  index2=0; while ( (tempbuff[index2] != ' ') && index2< strlen(tempbuff)) {
    index2++;
  }
  outfloat[index2]='\0';
  //printf("index is %d, outfloat now is %s\n", index2, outfloat);
  sprintf(tempbuff , " ");
  index2=0; while ( (tempbuff[index2] != ' ') && index2< strlen(tempbuff)) {
    index2++;
  }
  outfloat[index2]='\0';

  strcat(outbuff, outfloat); strcat(outbuff, " "); //el
  sprintf(tempbuff , "%10.10s ", " ");
  index2=0; while ( (tempbuff[index2] != ' ') && index2< strlen(tempbuff)) {
    index2++;
  }
  tempbuff[index2]='\0';
  strcat(outbuff, tempbuff); strcat(outbuff, " ");bzero(tempbuff, 128);
  sprintf(tempbuff , "%6.1fs ", 0.0);
  index2=0; while ( (tempbuff[index2] != ' ') && index2< strlen(tempbuff)) {
    index2++;
  }
  tempbuff[index2]='\0';
  strcat(outbuff, tempbuff); strcat(outbuff, " ");bzero(tempbuff, 128);

  sprintf(tempbuff," ");
  strcat(outbuff,tempbuff);
  bzero(tempbuff, 128);
  sprintf(tempbuff," ");
  strcat(outbuff,tempbuff);
  bzero(tempbuff, 128);

  strcat(outbuff," ");



    sockfd = socket(AF_INET, SOCK_STREAM, 0);
    if (sockfd < 0) 
        error("ERROR opening socket");
    server = gethostbyname("fourier.phys.utas.edu.au");
    if (server == NULL) {
        fprintf(stderr,"ERROR, no such host\n");
        //exit(0);
    }
    bzero((char *) &serv_addr, sizeof(serv_addr));
    serv_addr.sin_family = AF_INET;
    bcopy((char *)server->h_addr, 
         (char *)&serv_addr.sin_addr.s_addr,
         server->h_length);
    serv_addr.sin_port = htons(portno);
    if (connect(sockfd,(struct sockaddr *) &serv_addr,sizeof(serv_addr)) < 0) 
        error("ERROR connecting");
   write(sockfd,outbuff,strlen(outbuff));
	    close(sockfd);

}  /* end mout2 */


